"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.csvGenerate = exports.csvGenerateRow = void 0;
var csvGenerateRow = function (row, headerKeys, delimiter) {
    return headerKeys
        .map(function (fieldName) {
        return typeof row[fieldName] === "number"
            ? row[fieldName]
            : "\"".concat(String(row[fieldName]).replace(/"/g, '""'), "\"");
    })
        .join(delimiter);
};
exports.csvGenerateRow = csvGenerateRow;
var csvGenerate = function (data, headers, delimiter) {
    var headerKeys = Object.keys(data[0]);
    var columnNames = headers !== null && headers !== void 0 ? headers : headerKeys;
    var csv = data.map(function (row) { return (0, exports.csvGenerateRow)(row, headerKeys, delimiter); });
    csv.unshift(columnNames.join(delimiter));
    return csv.join("\r\n");
};
exports.csvGenerate = csvGenerate;
